VERSION 5.00
Begin VB.Form frmImages 
   Caption         =   "Create Raster Index Polygon"
   ClientHeight    =   2460
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4065
   LinkTopic       =   "Form1"
   ScaleHeight     =   2460
   ScaleWidth      =   4065
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSelAll 
      Caption         =   "SelectAllRaster"
      Height          =   375
      Left            =   2160
      TabIndex        =   8
      Top             =   1440
      Width           =   1815
   End
   Begin VB.ComboBox cboFilter 
      Height          =   315
      ItemData        =   "frmImages.frx":0000
      Left            =   120
      List            =   "frmImages.frx":0013
      TabIndex        =   4
      Text            =   "IMAGINE Image"
      Top             =   1920
      Width           =   1815
   End
   Begin VB.TextBox txtName 
      Height          =   375
      Left            =   2160
      TabIndex        =   3
      Text            =   "RasterIndexPoly"
      Top             =   720
      Width           =   1815
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3240
      TabIndex        =   2
      Top             =   1920
      Width           =   735
   End
   Begin VB.ListBox lstFiles 
      Height          =   645
      ItemData        =   "frmImages.frx":0048
      Left            =   120
      List            =   "frmImages.frx":004A
      MultiSelect     =   2  'Extended
      TabIndex        =   1
      Top             =   720
      Width           =   1815
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "OK"
      Height          =   375
      Left            =   2160
      TabIndex        =   0
      Top             =   1920
      Width           =   735
   End
   Begin VB.Label Label3 
      Caption         =   "Raster types:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Shapefile name:"
      Height          =   255
      Left            =   2160
      TabIndex        =   6
      Top             =   360
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "Select raster:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   360
      Width           =   1815
   End
End
Attribute VB_Name = "frmImages"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pGxApp As IGxApplication
Private m_pFolderName As String
Private m_pFileName As String
Private m_pGxObjEnum As IEnumGxObject

Public Sub Init(pGxApp As IGxApplication)
  Set m_pGxApp = pGxApp
End Sub

Private Sub cboFilter_Click()
  Dim i As Integer
  Dim pGxObject As IGxObject
  Dim pGxDS As IGxDataset
  Dim pRD As IRasterDataset
  
  'List different type of images according to filter
  m_pGxObjEnum.Reset
  Set pGxObject = m_pGxObjEnum.Next
  
  lstFiles.Clear
  i = cboFilter.ListIndex
  
  Do Until pGxObject Is Nothing
    If TypeOf pGxObject Is IGxDataset Then
      Set pGxDS = pGxObject
      If pGxDS.Dataset.Type = esriDTRasterDataset Then
        Set pRD = pGxDS.Dataset
        Select Case i
          Case 0
            If pRD.Format = "GRID" Then
              lstFiles.AddItem pGxObject.Name
            End If
          Case 1
            If pRD.Format = "IMAGINE Image" Then
              lstFiles.AddItem pGxObject.Name
            End If
          Case 2
            If pRD.Format = "TIFF" Then
              lstFiles.AddItem pGxObject.Name
            End If
          Case 3
            If pRD.Format = "JFIF" Then
              lstFiles.AddItem pGxObject.Name
            End If
          Case 4
              lstFiles.AddItem pGxObject.Name
        End Select
      End If
    End If
    Set pGxObject = m_pGxObjEnum.Next
  Loop

End Sub

Private Sub cmdCancel_Click()
  Unload Me
End Sub


Private Sub cmdGo_Click()
                    
  'Create polygon from raster image extent and insert the polygon feature to the shp file
  Dim pWSF As IWorkspaceFactory
  Dim pRWS As IRasterWorkspace
  Dim pRD As IRasterDataset
  Dim pRaster As IRaster
  Dim pRasterProp As IRasterProps
  Dim pRow As IRow
  Dim pFeatClass As IFeatureClass
  Dim pTable As ITable
  Dim pFeat As IFeature
  Dim pEnv As IEnvelope
  Dim pPntColl As IPointCollection
  Dim pPnt(3) As IPoint
  Dim i As Integer
  
  Set pWSF = New RasterWorkspaceFactory
  
  If lstFiles.SelCount = 0 Then
    'Image names must be selected on the listbox
    MsgBox "Please select the images"
  Else
    Set pFeatClass = CreateShpFile
    
    If Not pFeatClass Is Nothing Then
      If pWSF.IsWorkspace(m_pFolderName) Then
        Set pRWS = pWSF.OpenFromFile(m_pFolderName, 0)
      End If
      
      For i = 0 To lstFiles.ListCount - 1
        If lstFiles.Selected(i) Then
          Set pRD = pRWS.OpenRasterDataset(lstFiles.List(i))
          Set pRaster = pRD.CreateDefaultRaster()
          Set pRasterProp = pRaster
          
          'Assign each field for the feature
          Set pFeat = pFeatClass.CreateFeature
          pFeat.Value(2) = lstFiles.List(i)
          pFeat.Value(3) = m_pFolderName + "\" + lstFiles.List(i)
          pFeat.Value(4) = pRasterProp.Extent.XMin
          pFeat.Value(5) = pRasterProp.Extent.YMin
          pFeat.Value(6) = pRasterProp.Extent.XMax
          pFeat.Value(7) = pRasterProp.Extent.YMax
          
          'Create polygon feature
          Set pEnv = pRasterProp.Extent.Envelope
          Set pPntColl = New Polygon
          
          Set pPnt(0) = New Point
          pPnt(0).PutCoords pEnv.XMin, pEnv.YMin
          Set pPnt(1) = New Point
          pPnt(1).PutCoords pEnv.XMin, pEnv.YMax
          Set pPnt(2) = New Point
          pPnt(2).PutCoords pEnv.XMax, pEnv.YMax
          Set pPnt(3) = New Point
          pPnt(3).PutCoords pEnv.XMax, pEnv.YMin
          pPntColl.AddPoint pPnt(0)
          pPntColl.AddPoint pPnt(1)
          pPntColl.AddPoint pPnt(2)
          pPntColl.AddPoint pPnt(3)

          'store geometry in the feature
          Set pFeat.Shape = pPntColl
          pFeat.Store
        End If
      Next
      Unload Me
    End If
  End If
  
End Sub

Private Sub cmdSelAll_Click()
  'Select all images when pressing Ctrl+A
  Dim i As Integer
  For i = 0 To lstFiles.ListCount - 1
    lstFiles.Selected(i) = True
  Next i
End Sub

Private Sub Form_GotFocus()
MsgBox "Focus"
End Sub

Private Sub Form_Load()
  'Populate the names of raster images in the list box when form is loaded
  
  Dim pGxObj As IGxObject
  Dim pGxObjCont As IGxObjectContainer
  Dim pGxObject As IGxObject
  Dim pGxDS As IGxDataset
  Dim pRD As IRasterDataset
  
  Set pGxObj = m_pGxApp.Catalog.SelectedObject
  Set pGxObjCont = pGxObj
  Set m_pGxObjEnum = pGxObjCont.Children
  m_pGxObjEnum.Reset
  Set pGxObject = m_pGxObjEnum.Next
  
  
  'Record the name of the folder where the images are located to contain the shape file
  m_pFolderName = pGxObject.Parent.FullName
  m_pFileName = txtName.Text
  
  'List the image names according to the filter
  Do Until pGxObject Is Nothing
    If TypeOf pGxObject Is IGxDataset Then
      Set pGxDS = pGxObject
      If pGxDS.Dataset.Type = esriDTRasterDataset Then
        Set pRD = pGxDS.Dataset
        If pRD.Format = "IMAGINE Image" Then
          lstFiles.AddItem pGxObject.Name
        End If
      End If
    End If
    Set pGxObject = m_pGxObjEnum.Next
  Loop
  
End Sub

Private Function CreateShpFile() As IFeatureClass

  'Create a new shape file
  Dim pWSF As IWorkspaceFactory
  Dim pFWS As IFeatureWorkspace
  Dim pWS As IWorkspace
  Dim pEnumDS As IEnumDataset
  Dim pDS As IDataset
  Dim sFolderName As String
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pGxObj As IGxObject
  Dim iYes As Integer
  Dim pFeatDS As IFeatureDataset
  
  
  Set pWSF = New ShapefileWorkspaceFactory
  Set pFWS = pWSF.OpenFromFile(m_pFolderName, 0)

  'Delete the shape file if it is already exists
  Set pWS = pFWS
  Set pEnumDS = pWS.Datasets(esriDTFeatureClass)
  pEnumDS.Reset
  Set pDS = pEnumDS.Next
  Do Until pDS Is Nothing
    If pDS.Name = m_pFileName Then
      iYes = MsgBox("Shapefile already exists, delete it?", vbYesNo, "Delete existing file?")
      If iYes = vbYes Then
        pDS.Delete
      Else
        MsgBox "Rename the shapefile"
        Set CreateShpFile = Nothing
        Exit Function
      End If
    End If
    Set pDS = pEnumDS.Next
  Loop

  'Set up fields collection, which includes "SHAPE", "IMAGENAME", "FULLPATH", "XMIN",
    '"YMIN", "XMAX", "YMAX"
  Set pFields = New esriCore.Fields
  Set pFieldsEdit = pFields
  
  'Add "SHAPE" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  pFieldEdit.Name = "Shape"
  pFieldEdit.Type = esriFieldTypeGeometry
  
  Set pGeomDef = New GeometryDef
  Set pGeomDefEdit = pGeomDef
  With pGeomDefEdit
    .GeometryType = esriGeometryPolygon
    Set .SpatialReference = New UnknownCoordinateSystem
  End With
  
  Set pFieldEdit.GeometryDef = pGeomDef
  pFieldsEdit.AddField pField
  
  'Add "IMAGENAME" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 30
    .Name = "IMAGENAME"
    .Type = esriFieldTypeString
  End With
  pFieldsEdit.AddField pField
  
  'Add "FULLPATH" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 50
    .Name = "FULLPATH"
    .Type = esriFieldTypeString
  End With
  pFieldsEdit.AddField pField
  
  'Add "XMIN" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 10
    .Name = "XMIN"
    .Type = esriFieldTypeDouble
  End With
  pFieldsEdit.AddField pField
  
  'Add "YMIN" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 10
    .Name = "YMIN"
    .Type = esriFieldTypeDouble
  End With
  pFieldsEdit.AddField pField
  
  'Add "XMAX" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 10
    .Name = "XMAX"
    .Type = esriFieldTypeDouble
  End With
  pFieldsEdit.AddField pField
  
  'Add "YMAX" field
  Set pField = New esriCore.Field
  Set pFieldEdit = pField
  With pFieldEdit
    .Length = 10
    .Name = "YMAX"
    .Type = esriFieldTypeDouble
  End With
  pFieldsEdit.AddField pField
        
  'Create the shapefile
  Set CreateShpFile = pFWS.CreateFeatureClass(m_pFileName, pFields, Nothing, Nothing, _
                  esriFTSimple, "Shape", 0)
End Function

Private Sub Form_Unload(Cancel As Integer)
  Set m_pGxApp = Nothing
  Set m_pGxObjEnum = Nothing
End Sub

Private Sub txtName_Change()
  m_pFileName = txtName.Text
End Sub
